title: Installation

## Pre-requisites

* The [libPSML library](http://launchpad.net/libpsml) itself.

* The [xmlf90 library](http://launchpad.net/xmlf90)
  Follow the instructions in the package to compile it.

## Installation of libPSML

Create a building directory at the top level with any name. For example:

```
    mkdir Gfortran
```
    
Go into the building directory and copy the provided (minimal)
   macros file:

```
	cp ../src/fortran.mk .
```

(Make sure that the XMLF90_ROOT variable is appropriate.)

Now, still in the building directory, type:

```
     sh ../src/config.sh
```

This will create a building tree with the appropriate makefiles, and
   make a copy of the 'examples' directory.
   
Now type 'make' to build the library, and optionally

```
    make PREFIX=/path/to/installation install
```

to install the library and modules in some central place.

## Test programs

Go into the subdirectory `examples` *of the building directory*. In it
you can find, among others:

* [[normalize(program)]]:  A program to parse a PSML file and dump the resulting `ps`
object.

* [[show_psml(program)]]: A program to parse a PSML file and extract
  various kinds of information, with optional evaluation of radial
  functions on a linear grid for later plotting.

You can type `make` to build the executables.

## Compiling user programs

After installation, the appropriate modules and library files should
already be in `$PREFIX/include` and `$PREFIX/lib`, respectively.

To compile user programs, it is suggested that the user create a
separate directory to hold the program files and prepare a Makefile
following the templates in the `examples/` directory.

The basic idiom is to provide the basic Fortran building rules, and
to get the paths to the libpsml (and xmlf90) modules and library by importing the
`psml.mk` file in the top level of the installation directory.







